{**********************************************************}
{                                                          }
{          BLUE CODE for Delphi                            }
{                                                          }
{          Copyright (c) 1996-97 BlueCodeX                 }
{                                                          }
{**********************************************************}

unit EventDum;

{$B-,G+,I+,N+,P+,R-,S-,T-,W-,X+}
{$C MOVEABLE DEMANDLOAD DISCARDABLE}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs;

type
  TEventDummy = class(TComponent)
  private
    FShow: Boolean;
  public
    procedure SetEvents(Form: TForm);
  published
    procedure CloseForm(Sender: TObject; var Action: TCloseAction);
    procedure KeyEvent1(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure KeyEvent2(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure KeyPressEvent(Sender: TObject; var Key: Char);
    procedure MouseEvent1(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MouseEvent2(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure NotifyEvent1(Sender: TObject);
    procedure NotifyEvent2(Sender: TObject);
    property Show: Boolean read FShow write FShow;
  end;

var
  EventDummy: TEventDummy;

implementation

uses BlcUtils, DemConst;

procedure ShowEventInfo(EventHandler: String; Sender: TObject);
begin
  if EventDummy.Show then MessageDlg(FmtLoadStr(SEventInfoText,
   [EventHandler, GetObjectName(Sender)]), mtInformation, [mbOk], 0);
end;

procedure TEventDummy.SetEvents(Form: TForm);
begin
  if Form <> nil then
    with Form do
    begin
     OnClick := NotifyEvent1;
     OnDblClick := NotifyEvent2;
     OnKeyDown := KeyEvent1;
     OnKeyUp := KeyEvent2;
     OnKeyPress := KeyPressEvent;
     OnMouseDown := MouseEvent1;
     OnMouseUp := MouseEvent2;
     OnClose := CloseForm;
  end;
end;

{ immer zerstren }
procedure TEventDummy.CloseForm(Sender: TObject; var Action: TCloseAction);
begin
  if Action = caHide then Action := caFree;
end;

procedure TEventDummy.NotifyEvent1(Sender: TObject);
begin
  ShowEventInfo('NotifyEvent1', Sender);
end;

procedure TEventDummy.NotifyEvent2(Sender: TObject);
begin
  ShowEventInfo('NotifyEvent2', Sender);
end;

procedure TEventDummy.KeyEvent1(Sender: TObject; var Key: Word;
   Shift: TShiftState);
begin
  if not (ssAlt in Shift) then ShowEventInfo('KeyEvent1', Sender);
end;

procedure TEventDummy.KeyEvent2(Sender: TObject; var Key: Word;
   Shift: TShiftState);
begin
  if not (ssAlt in Shift) then ShowEventInfo('KeyEvent2', Sender);
end;

procedure TEventDummy.KeyPressEvent(Sender: TObject; var Key: Char);
begin
  ShowEventInfo('KeyPressEvent', Sender);
end;

procedure TEventDummy.MouseEvent1(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ShowEventInfo('MouseEvent1', Sender);
end;

procedure TEventDummy.MouseEvent2(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  ShowEventInfo('MouseEvent2', Sender);
end;

begin
  EventDummy := TEventDummy.Create(Application);
  EventDummy.Show := True;
end.
