{**********************************************************}
{                                                          }
{          BLUE CODE for Delphi                            }
{                                                          }
{          Copyright (c) 1996-97 BlueCodeX                 }
{                                                          }
{**********************************************************}

unit PrLtMain;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, RtReg, RtStdReg;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    ComboBox1: TComboBox;
    ListBox1: TListBox;
    ListBox2: TListBox;
    Memo1: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Panel1: TPanel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    RegStdPropertyEditors1: TRegStdPropertyEditors;
    procedure ListBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    { Dummy - Methoden }
    procedure Label1Click(Sender: TObject);
    procedure Label1DblClick(Sender: TObject);
    procedure Label1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure Label1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure Label1EndDrag(Sender, Target: TObject; X, Y: Integer);
    procedure Label1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Label1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Label1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel1Resize(Sender: TObject);
    procedure Panel1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure GroupBox1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure GroupBox2DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure GroupBox3EndDrag(Sender, Target: TObject; X, Y: Integer);
    procedure GroupBox4EndDrag(Sender, Target: TObject; X, Y: Integer);
    procedure ListBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ListBox2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ListBox2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private-Deklarationen }
    function GetSelProperty: Integer;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses
  DsgnIntf, PropInfo, TypInfo, DemoHelp, DemConst;

type
  TDemoInspector = class(TPropertyInspector)
  protected
    function GetSelProperty: Integer; override;
  end;

function TDemoInspector.GetSelProperty: Integer;
begin
  Result := Form1.GetSelProperty;
end;

var
  PropertyInspector: TDemoInspector;

procedure TForm1.ListBox1Click(Sender: TObject);
const
  DefaultValue = 'keine Einschrnkungen';
var
  I, J: Integer;
begin
  I := ListBox1.ItemIndex;
  if I <> -1 then with PropertyInspector.PropertyList do
  begin
    CheckBox1.Checked := paDialog in Attributes[I];
    CheckBox2.Checked := ReadOnly[I];
    CheckBox3.Checked := SubPropState[I] <> spNone;
    Label7.Caption := PropName[I];
    Label8.Caption := TypeKindToString(PropKind[I]);
    Label9.Caption := PropValue[I];
    Label10.Caption := IntToStr(EditLimit[I]);
    J := 0;
    while (J < Count) and not IsKindFrom(I, J) do Inc(J);
    CheckBox4.Checked := J <> Count;
    with ListBox2 do
    begin
      Items := ValidPropValues[I];
      if Items.Count = 0 then Items.Add(DefaultValue);
    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  I: Integer;
begin
  InitHelp;
  Application.HelpFile := LoadStr(SBlueCodeHelp);
  PropertyInspector := TDemoInspector.Create(self);
  with PropertyInspector do
  begin
    Form := self;
    PropertyFilter := tkAny;
    ComponentList := MakeComponentList([Label1]);
    { Untereigenschaften einfgen }
    with PropertyList do for I := 0 to Count - 1 do
      if SubPropState[I] = spHide then InsertSubProperties(I);
    ListBox1.Items := PropertyList.FullPropNames;
    ListBox1.ItemIndex := 4;
    ListBox1Click(self);
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FreeHelp;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_F1) and (Shift = []) then Application.HelpJump(
    LoadStr(SBlueCodeHelpPfx) + TPropEditList.Classname + 'Object');
end;

function TForm1.GetSelProperty: Integer;
begin
  Result := Listbox1.ItemIndex;
end;

{ Dummy - Funktionen, damit bei Methodeneigenschaften auch Werte angezeigt
  werden knnen }

procedure TForm1.Label1Click(Sender: TObject);
begin
  { }
end;

procedure TForm1.Label1DblClick(Sender: TObject);
begin
  { }
end;

procedure TForm1.Label1DragDrop(Sender, Source: TObject; X, Y: Integer);
begin
  { }
end;

procedure TForm1.Label1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  { }
end;

procedure TForm1.Label1EndDrag(Sender, Target: TObject; X, Y: Integer);
begin
  { }
end;

procedure TForm1.Label1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  { }
end;

procedure TForm1.Label1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  { }
end;

procedure TForm1.Label1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  { }
end;

procedure TForm1.Panel1Resize(Sender: TObject);
begin
  { }
end;

procedure TForm1.Panel1DragDrop(Sender, Source: TObject; X, Y: Integer);
begin
  { }
end;

procedure TForm1.GroupBox1DragDrop(Sender, Source: TObject; X, Y: Integer);
begin
  { }
end;

procedure TForm1.GroupBox2DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  { }
end;

procedure TForm1.GroupBox3EndDrag(Sender, Target: TObject; X, Y: Integer);
begin
  { }
end;

procedure TForm1.GroupBox4EndDrag(Sender, Target: TObject; X, Y: Integer);
begin
  { }
end;

procedure TForm1.ListBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  { }
end;

procedure TForm1.ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  { }
end;

procedure TForm1.ListBox2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  { }
end;

procedure TForm1.ListBox2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  { }
end;

end.
